Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Enums/JobState.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive.DataAccess/3.3/Enums/JobState.cs	(revision 6721)
+++ 	(revision )
@@ -1,67 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-
-namespace HeuristicLab.Services.Hive.DataAccess {
-  [Serializable]
-  public enum JobState {
-    /// <summary>
-    /// A job is offline as long as he is not yet submitted to the hive
-    /// </summary>
-    Offline,
-
-    /// <summary>
-    /// Job is waiting to be calculated
-    /// </summary>
-    Waiting,
-
-    /// <summary>
-    /// Job is beeing transferred
-    /// </summary>
-    Transferring,
-
-    /// <summary>
-    /// Job is actively calculated on a Slave
-    /// </summary>
-    Calculating,
-
-    /// <summary>
-    /// Job is paused, will not be picked up by slaves
-    /// </summary>
-    Paused,
-
-    /// <summary>
-    /// Job as finished and is ready to be collected by the Client
-    /// </summary>
-    Finished,
-
-    /// <summary>
-    /// Job is aborted and result can be collected by the Client
-    /// </summary>
-    Aborted,
-
-    /// <summary>
-    /// Job as been aborted due to an error. Results are ready to be collected
-    /// </summary>
-    Failed
-  };
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Job.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/Job.cs	(revision 6721)
+++ 	(revision )
@@ -1,53 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Runtime.Serialization;
-
-namespace HeuristicLab.Services.Hive.DataTransfer {
-  [DataContract]
-  [Serializable]
-  public class Job : LightweightJob {
-    [DataMember]
-    public int Priority { get; set; }
-    [DataMember]
-    public int CoresNeeded { get; set; }
-    [DataMember]
-    public int MemoryNeeded { get; set; }
-    [DataMember]
-    public List<Guid> PluginsNeededIds { get; set; }
-    [DataMember]
-    public DateTime? LastHeartbeat { get; set; }
-    [DataMember]
-    public bool IsParentJob { get; set; }
-    [DataMember]
-    public bool FinishWhenChildJobsFinished { get; set; }
-    [DataMember]
-    public Guid HiveExperimentId { get; set; }
-    [DataMember]
-    public bool IsPrivileged { get; set; }
-
-    public Job() {
-      this.PluginsNeededIds = new List<Guid>();
-    }
-  }
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/JobData.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/JobData.cs	(revision 6721)
+++ 	(revision )
@@ -1,38 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Runtime.Serialization;
-
-namespace HeuristicLab.Services.Hive.DataTransfer {
-  [DataContract]
-  [Serializable]
-  public class JobData {
-    [DataMember]
-    public Guid JobId { get; set; }
-    [DataMember]
-    public byte[] Data { get; set; }
-    [DataMember]
-    public DateTime LastUpdate { get; set; }
-
-    public JobData() { }
-  }
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/JobState.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/JobState.cs	(revision 6721)
+++ 	(revision )
@@ -1,92 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-
-namespace HeuristicLab.Services.Hive.DataTransfer {
-  [Serializable]
-  public enum JobState {
-    /// <summary>
-    /// A job is offline as long as he is not yet submitted to the hive
-    /// </summary>
-    Offline,
-
-    /// <summary>
-    /// Job is waiting to be calculated
-    /// </summary>
-    Waiting,
-
-    /// <summary>
-    /// Job is beeing transferred
-    /// </summary>
-    Transferring,
-
-    /// <summary>
-    /// Job is actively calculated on a Slave
-    /// </summary>
-    Calculating,
-
-    /// <summary>
-    /// Job is paused, will not be picked up by slaves
-    /// </summary>
-    Paused,
-
-    /// <summary>
-    /// Job as finished and is ready to be collected by the Client
-    /// </summary>
-    Finished,
-
-    /// <summary>
-    /// Job is aborted and result can be collected by the Client
-    /// </summary>
-    Aborted,
-
-    /// <summary>
-    /// Job as been aborted due to an error. Results are ready to be collected
-    /// </summary>
-    Failed
-  };
-
-  public static class JobStateExtensions {
-    /// <summary>
-    /// This job is not yet done
-    /// </summary>
-    public static bool IsActive(this JobState jobState) {
-      return !jobState.IsDone();
-    }
-
-    /// <summary>
-    /// This job is Waiting
-    /// </summary>
-    public static bool IsWaiting(this JobState jobState) {
-      return jobState == JobState.Waiting;
-    }
-
-    /// <summary>
-    /// This job is Finished || Failed || Aborted
-    /// </summary>
-    public static bool IsDone(this JobState jobState) {
-      return jobState == JobState.Finished ||
-        jobState == JobState.Aborted ||
-        jobState == JobState.Failed;
-    }
-  }
-}
Index: anches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/LightweightJob.cs
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Services.Hive/3.3/DataTransfer/LightweightJob.cs	(revision 6721)
+++ 	(revision )
@@ -1,62 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Runtime.Serialization;
-
-namespace HeuristicLab.Services.Hive.DataTransfer {
-  [DataContract]
-  [Serializable]
-  public class LightweightJob : HiveItem {
-    [DataMember]
-    public TimeSpan ExecutionTime { get; set; }
-    [DataMember]
-    public Guid? ParentJobId { get; set; }
-    [DataMember]
-    public List<StateLog> StateLog { get; set; }
-    [DataMember]
-    public JobState State { get; set; }
-    [DataMember]
-    public Command? Command { get; set; }
-    [DataMember]
-    public DateTime LastJobDataUpdate { get; set; }
-
-    public StateLog CurrentStateLog { get { return StateLog.LastOrDefault(); } }
-    public DateTime? DateCreated { get { return StateLog.Count > 0 ? new DateTime?(StateLog.First().DateTime) : null; } }
-    public DateTime? DateFinished { get { return (StateLog.Count > 0 && CurrentStateLog.State == JobState.Finished) ? new DateTime?(CurrentStateLog.DateTime) : null; } }
-
-    public LightweightJob() {
-      StateLog = new List<DataTransfer.StateLog>();
-    }
-
-    public LightweightJob(Job job) {
-      this.Id = job.Id;
-      this.ExecutionTime = job.ExecutionTime;
-      this.ParentJobId = job.ParentJobId;
-      this.StateLog = new List<StateLog>(job.StateLog);
-      this.State = job.State;
-      this.Command = job.Command;
-      this.LastJobDataUpdate = job.LastJobDataUpdate;
-    }
-  }
-}