Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLab.Clients.Hive.Slave.App-3.3.csproj
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLab.Clients.Hive.Slave.App-3.3.csproj	(revision 6730)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLab.Clients.Hive.Slave.App-3.3.csproj	(revision 6731)
@@ -52,20 +52,20 @@
   <ItemGroup>
     <Reference Include="HeuristicLab.Common-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Common-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Core-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Core-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.Core.Views-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.Core.Views-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.Core.Views-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.MainForm-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.MainForm.WindowsForms-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.MainForm.WindowsForms-3.3.dll</HintPath>
     </Reference>
     <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
-      <HintPath>..\..\..\..\..\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+      <HintPath>C:\Program Files\HeuristicLab 3.3\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
     </Reference>
     <Reference Include="System" />
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLabClientsHiveSlaveAppPlugin.cs.frame
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLabClientsHiveSlaveAppPlugin.cs.frame	(revision 6730)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave.App/3.3/HeuristicLabClientsHiveSlaveAppPlugin.cs.frame	(revision 6731)
@@ -34,4 +34,7 @@
   [PluginDependency("HeuristicLab.Core", "3.3")]  
   [PluginDependency("HeuristicLab.Common", "3.3")]  
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm", "3.3")]
+  [PluginDependency("HeuristicLab.MainForm.WindowsForms", "3.3")]
   public class HeuristicLabClientsHiveSlaveAppPlugin : PluginBase {
   }
Index: /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive 3.4.sln
===================================================================
--- /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive 3.4.sln	(revision 6730)
+++ /branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Hive 3.4.sln	(revision 6731)
@@ -80,17 +80,17 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.HiveEngine.Views-3.3", "HeuristicLab.HiveEngine.Views\3.3\HeuristicLab.HiveEngine.Views-3.3.csproj", "{E37F15E0-D0D6-4C6E-AD22-0DA514C943A3}"
 EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.HiveEngine.ConsoleTests-3.3", "HeuristicLab.HiveEngine\3.3\Tests\HeuristicLab.HiveEngine.ConsoleTests-3.3.csproj", "{87D9FBB9-8E54-4770-9C84-B4B571D9EDD5}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.ExperimentManager-3.3", "HeuristicLab.Clients.Hive.ExperimentManager\3.3\HeuristicLab.Clients.Hive.ExperimentManager-3.3.csproj", "{DBFD7205-61AF-40EF-8776-3052DEF91CF3}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Administrator-3.3", "HeuristicLab.Clients.Hive.Administrator\3.3\HeuristicLab.Clients.Hive.Administrator-3.3.csproj", "{5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIcon\3.3\HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj", "{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}"
+EndProject
+Project("{54435603-DBB4-11D2-8724-00A0C9A8B90C}") = "HeuristicLab.Clients.Hive.Slave.TrayIconSetup-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIconSetup\HeuristicLab.Clients.Hive.Slave.TrayIconSetup.vdproj", "{E2171917-7CD6-4C03-BA98-7DF4B5FA42D6}"
+EndProject
+Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.App-3.3", "HeuristicLab.Clients.Hive.Slave.App\3.3\HeuristicLab.Clients.Hive.Slave.App-3.3.csproj", "{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}"
+EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.ConsoleClient-3.4", "HeuristicLab.Clients.Hive.Slave.ConsoleClient\HeuristicLab.Clients.Hive.Slave.ConsoleClient-3.4.csproj", "{464D70B8-2D91-485C-B622-22E4A4891C68}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.HiveEngine.ConsoleTests-3.3", "HeuristicLab.HiveEngine\3.3\Tests\HeuristicLab.HiveEngine.ConsoleTests-3.3.csproj", "{87D9FBB9-8E54-4770-9C84-B4B571D9EDD5}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.ExperimentManager-3.3", "HeuristicLab.Clients.Hive.ExperimentManager\3.3\HeuristicLab.Clients.Hive.ExperimentManager-3.3.csproj", "{DBFD7205-61AF-40EF-8776-3052DEF91CF3}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Administrator-3.3", "HeuristicLab.Clients.Hive.Administrator\3.3\HeuristicLab.Clients.Hive.Administrator-3.3.csproj", "{5211F1AD-BBA2-4C62-8749-DCA0A25CF5D8}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIcon\3.3\HeuristicLab.Clients.Hive.Slave.TrayIcon-3.3.csproj", "{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA}"
-EndProject
-Project("{54435603-DBB4-11D2-8724-00A0C9A8B90C}") = "HeuristicLab.Clients.Hive.Slave.TrayIconSetup-3.3", "HeuristicLab.Clients.Hive.Slave.TrayIconSetup\HeuristicLab.Clients.Hive.Slave.TrayIconSetup.vdproj", "{E2171917-7CD6-4C03-BA98-7DF4B5FA42D6}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Clients.Hive.Slave.App-3.3", "HeuristicLab.Clients.Hive.Slave.App\3.3\HeuristicLab.Clients.Hive.Slave.App-3.3.csproj", "{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}"
 EndProject
 Global
@@ -314,18 +314,4 @@
 		{E37F15E0-D0D6-4C6E-AD22-0DA514C943A3}.Release|x86.ActiveCfg = Release|x86
 		{E37F15E0-D0D6-4C6E-AD22-0DA514C943A3}.Release|x86.Build.0 = Release|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.ActiveCfg = Debug|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.ActiveCfg = Debug|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.Build.0 = Debug|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Mixed Platforms.Build.0 = Release|Any CPU
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.ActiveCfg = Release|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.ActiveCfg = Release|x86
-		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.Build.0 = Release|x86
 		{87D9FBB9-8E54-4770-9C84-B4B571D9EDD5}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{87D9FBB9-8E54-4770-9C84-B4B571D9EDD5}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -418,4 +404,18 @@
 		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.ActiveCfg = Release|x86
 		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5}.Release|x86.Build.0 = Release|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Any CPU.Build.0 = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x64.ActiveCfg = Debug|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.ActiveCfg = Debug|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Debug|x86.Build.0 = Debug|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.ActiveCfg = Release|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Any CPU.Build.0 = Release|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Mixed Platforms.ActiveCfg = Release|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|Mixed Platforms.Build.0 = Release|Any CPU
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x64.ActiveCfg = Release|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.ActiveCfg = Release|x86
+		{464D70B8-2D91-485C-B622-22E4A4891C68}.Release|x86.Build.0 = Release|x86
 	EndGlobalSection
 	GlobalSection(SolutionProperties) = preSolution
@@ -428,12 +428,12 @@
 		{28711372-0255-4883-9BED-81E150D73880} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
 		{989FE92B-484E-41EE-87E2-6A24AF0381D8} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
-		{464D70B8-2D91-485C-B622-22E4A4891C68} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
 		{7C4B1DE4-FC9A-4448-BCF8-3CB3FA3CB8FA} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
 		{E2171917-7CD6-4C03-BA98-7DF4B5FA42D6} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
 		{E3B93D5C-3B6B-4657-9B3E-F4297BAC0AA5} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
-		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC} = {E69A1E5F-63F7-493F-BBA2-163D6E321D44}
+		{464D70B8-2D91-485C-B622-22E4A4891C68} = {622F8E95-CDFC-4B4E-BBA7-3EE4E47DB52A}
 		{CF9DA321-AC1B-4FD3-9EC3-67BC6B861BDE} = {E69A1E5F-63F7-493F-BBA2-163D6E321D44}
 		{0CA6706D-A569-45DE-A85C-4158891CC1BC} = {E69A1E5F-63F7-493F-BBA2-163D6E321D44}
 		{17187EAC-5D8C-4B11-9CEA-D88F71B59658} = {E69A1E5F-63F7-493F-BBA2-163D6E321D44}
+		{EC2C8109-6E1E-4C88-9A2B-908CFF2EF4AC} = {E69A1E5F-63F7-493F-BBA2-163D6E321D44}
 		{E1D6C801-892A-406A-B606-F158E36DD3C3} = {E46F2FC8-8C15-48E5-96DB-FF2DB36BC509}
 		{8D40A723-139D-40E4-8BBA-4CB309A9E4B9} = {E46F2FC8-8C15-48E5-96DB-FF2DB36BC509}